--Legal Notice: (C)2009 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.
------------------------------------------------------------------------------
-- Title:       ddr3_x16_bts_top.vhd                                    --
-- Author:	San Diego High Speed Design Team                    	    --
-- Rev:         Rev 0.1                                                     --
-- Description: ddr3 x16 with NIOS BTS					    --
------------------------------------------------------------------------------
-- Revision History:                                                        --
-- 1: Initial								    --
-------- 1 ------- 2 ------- 3 ------- 4 ------- 5 ------- 6 ------- 7 ------7
-------- 0 ------- 0 ------- 0 ------- 0 ------- 0 ------- 0 ------- 0 ------8
--Copyright  2009 Altera Corporation. All rights reserved.  Altera products
--are protected under numerous U.S. and foreign patents, maskwork rights,
--copyrights and other intellectual property laws.   
--                 
--This reference design file, and your use thereof, is subject to and
--governed by the terms and conditions of the applicable Altera Reference
--Design License Agreement.  By using this reference design file, you
--indicate your acceptance of such terms and conditions between you and
--Altera Corporation.  In the event that you do not agree with such terms and
--conditions, you may not use the reference design file. Please promptly                         
--destroy any copies you have made.
--
--This reference design file being provided on an "as-is" basis and as an
--accommodation and therefore all warranties, representations or guarantees
--of any kind (whether express, implied or statutory) including, without
--limitation, warranties of merchantability, non-infringement, or fitness for
--a particular purpose, are specifically disclaimed.  By making this
--reference design file available, Altera expressly does not recommend,
--suggest or require that this reference design file be used in combination 
--with any other product not provided by Altera
------------------------------------------------------------------------------



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library altera_mf;
use altera_mf.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- megafunction wizard: %DDR3 SDRAM High Performance Controller v8.1%
--GENERATION: XML
--Generated by DDR3 SDRAM High Performance Controller 8.1 [Altera, IP Toolbench v1.3.0 build58]
--IPFS_FILES:
--RELATED_FILES:
--<< MEGAWIZARD PARSE FILE DDR39.0
--.
--<< START MEGAWIZARD INSERT MODULE
       

 
--	 	Arria II GX FPGA Host Development Kit
--	
--	// Pushbutton, Dip Switch, and LED Definitions
--	FPGA_RST		Resets the Board Test System
--	PB0			Start
--	PB1			Create Error
--	PB0 & PB1		Press PB0 and PB1, then reset both, to reset NIOS  
--	Not currently active (comment in and recompile to use these):
--	USER_DIP[0]		0=Enable GUI ddr3 top global reset, 1=disable
--	USER_DIP[1]		0=Enable GUI ddr3 top soft reset, 1=disable
--	//  LED indicators combine transceiver, source synchronous, and low speed interfaces, for each test enabled by the user_dipsw
--	LED0			PLLs are locked.
--	LED1			Start Read
--	LED2			Test Complete  
--	LED2			Error 

--	
--	
--	 Arria II GX DDR3 Device Test Instructions:
--	 
--	1)	Set SW4=[00000011]  (1 is toward the HSMC interface, 0 is toward the PCIe Edge Interface)
--	2)	Plug in the USB Blaster cable to the JTAG connector.
--	3)	Power on the board.
--	4)	Using the Quartus Programmer, program the ddr3_x16.sof into the
--	    	Arria IV GX FPGA Development Kit.
--	6)	Press and release the FPGA_RST pushbutton.  	
--	7)	Press and release PB0
--	10)	Confirm LEDS 0, 1 and 2 illuminate, and LED 3 is not illuminated.
--	11)	Press and release PB1 (create tx error)
--	12)	Confirm LED3 is illuminated.
--	13) 	Repeat steps 6-12 to confirm the results
--	NOTE:  	If the test does not pass, wait a few seconds after step 6 to allow
--		NIOS software to initialize before pressing PB0        
--
--	To run with NIOS software, compile the project in the software folder using NIOS IDE.
  
entity ddr3_x16_bts_top is 
        port (
                 --signal clock_source : IN STD_LOGIC;
                 --signal global_reset_n : IN STD_LOGIC;
                 signal mem_addr : OUT STD_LOGIC_VECTOR (12 DOWNTO 0);
                 signal mem_ba : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal mem_cas_n : OUT STD_LOGIC;
                 signal mem_cke : OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
                 signal mem_clk : INOUT STD_LOGIC_VECTOR (0 DOWNTO 0);
                 signal mem_clk_n : INOUT STD_LOGIC_VECTOR (0 DOWNTO 0);
                 signal mem_cs_n : OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
                 signal mem_dm : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal mem_dq : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal mem_dqs : INOUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal mem_dqsn : INOUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal mem_odt : OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
                 signal mem_ras_n : OUT STD_LOGIC;
                 signal mem_reset_n : OUT STD_LOGIC;
                 signal mem_we_n : OUT STD_LOGIC;
                 --signal pnf : OUT STD_LOGIC;
                 --signal pnf_per_byte : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 --signal test_complete : OUT STD_LOGIC;
                 --signal test_status : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 signal clkin_bot_p : IN STD_LOGIC;	-- default 100 MHz
                 signal clkin_top_p : IN STD_LOGIC;	-- default 125 MHz                           
		 		 signal user_dipsw : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		 		 signal user_led : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
		 		 signal user_pb : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
		 		 signal cpu_resetn : IN STD_LOGIC;
		 		 
		fsm_a : out std_logic_vector(25 downto 0);              --2.5V      --FSM Address Bus (1Gb Flash)
		fsm_d : inout std_logic_vector(31 downto 0);              --2.5V      --FSM Data Bus

		max2_clk : out std_logic;           --1.8V
		max2_csn : out std_logic;           --1.8V
		max2_ben : out std_logic_vector(3 downto 0);           --1.8V
		max2_oen : out std_logic;           --1.8V
		max2_wen : out std_logic;           --1.8V
		
		pcie_led_x1 : out std_logic;
		pcie_led_x4 : out std_logic;
		pcie_led_x8 : out std_logic
		
		 		 		 
              );
end entity ddr3_x16_bts_top;
     

architecture europa of ddr3_x16_bts_top is
  component ddr3_x16 is
PORT (
    signal mem_cke : OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
        signal mem_dqsn : INOUT STD_LOGIC_VECTOR (1 DOWNTO 0);
        signal mem_addr : OUT STD_LOGIC_VECTOR (12 DOWNTO 0);
        signal mem_dm : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
        signal aux_full_rate_clk : OUT STD_LOGIC;
        signal local_init_done : OUT STD_LOGIC;
        signal mem_dq : INOUT STD_LOGIC_VECTOR (15 DOWNTO 0);
        signal mem_ras_n : OUT STD_LOGIC;
        signal mem_cs_n : OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
        signal phy_clk : OUT STD_LOGIC;
        signal mem_ba : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
        signal mem_reset_n : OUT STD_LOGIC;
        signal dqs_delay_ctrl_export : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
        signal aux_half_rate_clk : OUT STD_LOGIC;
        signal local_rdata : OUT STD_LOGIC_VECTOR (63 DOWNTO 0);
        signal local_rdata_valid : OUT STD_LOGIC;
        signal mem_we_n : OUT STD_LOGIC;
        signal reset_phy_clk_n : OUT STD_LOGIC;
        signal local_ready : OUT STD_LOGIC;
        signal mem_odt : OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
        signal mem_cas_n : OUT STD_LOGIC;
        signal dll_reference_clk : OUT STD_LOGIC;
        signal mem_clk : INOUT STD_LOGIC_VECTOR (0 DOWNTO 0);
        signal local_refresh_ack : OUT STD_LOGIC;
        signal local_wdata_req : OUT STD_LOGIC;
        signal reset_request_n : OUT STD_LOGIC;
        signal mem_dqs : INOUT STD_LOGIC_VECTOR (1 DOWNTO 0);
        signal mem_clk_n : INOUT STD_LOGIC_VECTOR (0 DOWNTO 0);
--        signal local_size : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
        signal local_size : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
        signal local_wdata : IN STD_LOGIC_VECTOR (63 DOWNTO 0);
        signal soft_reset_n : IN STD_LOGIC;
        signal global_reset_n : IN STD_LOGIC;
        signal local_burstbegin : IN STD_LOGIC;
        signal local_write_req : IN STD_LOGIC;
        signal local_address : IN STD_LOGIC_VECTOR (23 DOWNTO 0);
        signal pll_ref_clk : IN STD_LOGIC;
        signal local_be : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
        signal local_read_req : IN STD_LOGIC
      );
  end component ddr3_x16;
                    
  component nios_bts is
  PORT  (                                                                           
      		signal	  avalon_led_from_the_nios_bts_port_ddr3_x16_0               :	OUT  STD_LOGIC_VECTOR	(  7 DOWNTO 0)       ;
      		signal	  error_latch_from_the_nios_bts_port_ddr3_x16_0              :	OUT  STD_LOGIC		                     ;
      		signal	  local_addr_from_the_nios_bts_port_ddr3_x16_0               :	OUT  STD_LOGIC_VECTOR	( 23 DOWNTO 0)       ;
      		signal	  local_be_from_the_nios_bts_port_ddr3_x16_0                 :	OUT  STD_LOGIC_VECTOR	(  7 DOWNTO 0)       ;
      		signal	  local_burst_begin_from_the_nios_bts_port_ddr3_x16_0        :	OUT  STD_LOGIC		                     ;
      		signal	  local_read_req_from_the_nios_bts_port_ddr3_x16_0           :	OUT  STD_LOGIC		                     ;
      		signal	  local_reset_n_from_the_nios_bts_port_ddr3_x16_0            :	OUT  STD_LOGIC		                     ;
      		signal	  local_size_from_the_nios_bts_port_ddr3_x16_0               :	OUT  STD_LOGIC_VECTOR	(  2 DOWNTO 0)       ;
      		signal	  local_wdata_from_the_nios_bts_port_ddr3_x16_0              :	OUT  STD_LOGIC_VECTOR	( 63 DOWNTO 0)       ;
      		signal	  local_write_req_from_the_nios_bts_port_ddr3_x16_0          :	OUT  STD_LOGIC		                     ;
      		signal	  pattern_sync_acquired_from_the_nios_bts_port_ddr3_x16_0    :	OUT  STD_LOGIC		                     ;
      		signal	  plls_locked_from_the_nios_bts_port_ddr3_x16_0              :	OUT  STD_LOGIC		                     ;
      		signal	  test_complete_from_the_nios_bts_port_ddr3_x16_0            :	OUT  STD_LOGIC		                     ;
      		signal	  avalon_dip_to_the_nios_bts_port_ddr3_x16_0                 :	IN   STD_LOGIC_VECTOR	(  7 DOWNTO 0)       ;
      		signal	  avalon_pb_to_the_nios_bts_port_ddr3_x16_0                  :	IN   STD_LOGIC_VECTOR	(  7 DOWNTO 0)       ;
      		signal	  clk_0                                                      :	IN   STD_LOGIC		                     ;
      		signal	  create_error_pb_to_the_nios_bts_port_ddr3_x16_0            :	IN   STD_LOGIC		                     ;
      		signal	  local_clk_to_the_nios_bts_port_ddr3_x16_0                  :	IN   STD_LOGIC		                     ;
      		signal	  local_init_done_to_the_nios_bts_port_ddr3_x16_0            :	IN   STD_LOGIC		                     ;
      		signal	  local_rdata_to_the_nios_bts_port_ddr3_x16_0                :	IN   STD_LOGIC_VECTOR	( 63 DOWNTO 0)       ;
      		signal	  local_rdata_valid_to_the_nios_bts_port_ddr3_x16_0          :	IN   STD_LOGIC	                             ;
      		signal	  local_rdvalid_in_n_to_the_nios_bts_port_ddr3_x16_0         :	IN   STD_LOGIC	                             ;
      		signal	  local_ready_to_the_nios_bts_port_ddr3_x16_0                :	IN   STD_LOGIC	                             ;
      		signal	  local_wdata_req_to_the_nios_bts_port_ddr3_x16_0            :	IN   STD_LOGIC	                             ;
      		signal	  plls_in_locked_to_the_nios_bts_port_ddr3_x16_0             :	IN   STD_LOGIC	                             ;
      		signal	  reset_n                                                    :	IN   STD_LOGIC	                             ;
      		signal	  reset_n_to_the_nios_bts_port_ddr3_x16_0                    :	IN   STD_LOGIC	                             ;
      		signal	  start_pb_to_the_nios_bts_port_ddr3_x16_0                   :	IN   STD_LOGIC;

			signal adsc_n_to_the_max2_inf : out std_logic;
			signal bw_n_to_the_max2_inf : out std_logic_vector(3 downto 0);
			signal bwe_n_to_the_max2_inf : out std_logic;
			signal chipenable1_n_to_the_max2_inf : out std_logic;
			signal outputenable_n_to_the_max2_inf : out std_logic;
			signal tri_state_bridge_0_address : out std_logic_vector(19 downto 0);
			signal tri_state_bridge_0_data : inout std_logic_vector(31 downto 0);

			signal led_from_the_heartbeat_0 : out std_logic
      			         
	);
  end component nios_bts;
  
   component nios2_pll
	PORT
	(
		inclk0 : IN STD_LOGIC  := '0';
		c0		 : OUT STD_LOGIC 
	);
	end component;
	
                signal dll_reference_clk_sig :  STD_LOGIC;
                signal dqs_delay_ctrl_export_sig :  STD_LOGIC_VECTOR (5 DOWNTO 0);
                signal internal_mem_addr :  STD_LOGIC_VECTOR (12 DOWNTO 0);
                signal internal_mem_ba :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal internal_mem_cas_n :  STD_LOGIC;
                signal internal_mem_cke :  STD_LOGIC_VECTOR (0 DOWNTO 0);
                signal internal_mem_cs_n :  STD_LOGIC_VECTOR (0 DOWNTO 0);
                signal internal_mem_dm :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal internal_mem_odt :  STD_LOGIC_VECTOR (0 DOWNTO 0);
                signal internal_mem_ras_n :  STD_LOGIC;
                signal internal_mem_reset_n :  STD_LOGIC;
                signal internal_mem_we_n :  STD_LOGIC;
                signal internal_pnf :  STD_LOGIC;
                signal internal_pnf_per_byte :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_test_complete :  STD_LOGIC;
                signal internal_test_status :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal local_burstbegin_sig :  STD_LOGIC;
                signal mem_aux_full_rate_clk :  STD_LOGIC;
                signal mem_aux_half_rate_clk :  STD_LOGIC;
                signal mem_local_addr :  STD_LOGIC_VECTOR (23 DOWNTO 0);
                signal mem_local_be :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal mem_local_col_addr :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal mem_local_cs_addr :  STD_LOGIC;
                signal mem_local_rdata :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal mem_local_rdata_valid :  STD_LOGIC;
                signal mem_local_read_req :  STD_LOGIC;
                signal mem_local_ready :  STD_LOGIC;
                signal mem_local_size :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal mem_local_wdata :  STD_LOGIC_VECTOR (63 DOWNTO 0);
                signal mem_local_write_req :  STD_LOGIC;
                signal phy_clk :  STD_LOGIC;
                signal reset_phy_clk_n :  STD_LOGIC;
                signal tie_high :  STD_LOGIC;
                signal tie_low :  STD_LOGIC;
   
                -- Added for NIOS BTS:
		signal internal_mem_local_wdata_req : STD_LOGIC;
		signal internal_local_burstbegin_sig : STD_LOGIC;
		signal ddr3_global_reset_n	: STD_LOGIC;
		signal ddr3_soft_reset_n : STD_LOGIC;
		signal gpo : STD_LOGIC_VECTOR (7 DOWNTO 0);
		signal led_heartbeat : std_logic;
		signal	nios_clk : std_logic;	
 		signal	error_latch : std_logic;
 		signal	tst_complete : std_logic;
 		signal	pattern_sync_acquired : std_logic;
 		signal	plls_locked : std_logic;	
 		signal	nios_reset_n : std_logic;	
		
		signal led_from_the_heartbeat_0 : std_logic;
		signal adsc_n_to_the_max2_inf : std_logic;

begin

  --
 
  --
 
  --<< END MEGAWIZARD INSERT MODULE

  tie_high <= std_logic'('1');
  tie_low <= std_logic'('0');
  --<< START MEGAWIZARD INSERT WRAPPER_NAME
  ddr3_x16_inst : ddr3_x16
    port map(
            aux_full_rate_clk => mem_aux_full_rate_clk,
            aux_half_rate_clk => mem_aux_half_rate_clk,
            dll_reference_clk => dll_reference_clk_sig,
            dqs_delay_ctrl_export => dqs_delay_ctrl_export_sig,
            global_reset_n => ddr3_global_reset_n,
            local_address => mem_local_addr,
            local_be => mem_local_be,
            local_burstbegin => local_burstbegin_sig,
            local_init_done => open,
            local_rdata => mem_local_rdata,
            local_rdata_valid => mem_local_rdata_valid,
            local_read_req => mem_local_read_req,
            local_ready => mem_local_ready,
            local_refresh_ack => open,
            local_size => mem_local_size,
            local_wdata => mem_local_wdata,
            local_wdata_req => open,
            local_write_req => mem_local_write_req,
            mem_addr => internal_mem_addr,
            mem_ba => internal_mem_ba,
            mem_cas_n => internal_mem_cas_n,
            mem_cke(0) => internal_mem_cke(0),
            mem_clk(0) => mem_clk(0),
            mem_clk_n(0) => mem_clk_n(0),
            mem_cs_n(0) => internal_mem_cs_n(0),
            mem_dm => internal_mem_dm(1 DOWNTO 0),
            mem_dq => mem_dq,
            mem_dqs => mem_dqs(1 DOWNTO 0),
            mem_dqsn => mem_dqsn(1 DOWNTO 0),
            mem_odt(0) => internal_mem_odt(0),
            mem_ras_n => internal_mem_ras_n,
            mem_reset_n => internal_mem_reset_n,
            mem_we_n => internal_mem_we_n,
            phy_clk => phy_clk,
            pll_ref_clk => clkin_top_p,
            reset_phy_clk_n => reset_phy_clk_n,
            reset_request_n => open,
            soft_reset_n => ddr3_soft_reset_n  -- tie_high
    );

  --<< END MEGAWIZARD INSERT WRAPPER_NAME

  --<< START MEGAWIZARD INSERT CS_ADDR_MAP
  --connect up the column address bits, dropping 2 bits from example driver output because of 4:1 data rate
  ----mem_local_addr(7 DOWNTO 0) <= mem_local_col_addr(9 DOWNTO 2);
  --<< END MEGAWIZARD INSERT CS_ADDR_MAP
      
  
    nios_bts_i	: nios_bts
    	port map
	(                                                                                                                                
      		avalon_dip_to_the_nios_bts_port_ddr3_x16_0              =>	'0' & '0' & '0' & '0' & user_dipsw(3 DOWNTO 0)                                   ,
      		avalon_led_from_the_nios_bts_port_ddr3_x16_0            =>	gpo                                                      ,
      		avalon_pb_to_the_nios_bts_port_ddr3_x16_0               =>	'0' & '0' & '0' & '0' & '0' & '0' & user_pb(1 DOWNTO 0)  ,
      		clk_0                                                   =>	nios_clk                                                 ,
      		create_error_pb_to_the_nios_bts_port_ddr3_x16_0         =>	not user_pb(1)                                           ,
      		error_latch_from_the_nios_bts_port_ddr3_x16_0           =>	error_latch                                              ,
      		local_addr_from_the_nios_bts_port_ddr3_x16_0            =>	mem_local_addr	                                         ,
      		local_be_from_the_nios_bts_port_ddr3_x16_0              =>	mem_local_be	                                         ,
      		local_burst_begin_from_the_nios_bts_port_ddr3_x16_0     =>	internal_local_burstbegin_sig                            ,
      		local_clk_to_the_nios_bts_port_ddr3_x16_0               =>	phy_clk                                                  ,
      		local_init_done_to_the_nios_bts_port_ddr3_x16_0         => 	'1'	                                                 	 ,
      		local_rdata_to_the_nios_bts_port_ddr3_x16_0             =>	mem_local_rdata                                          ,
      		local_rdata_valid_to_the_nios_bts_port_ddr3_x16_0       =>	mem_local_rdata_valid                                    ,
      		local_rdvalid_in_n_to_the_nios_bts_port_ddr3_x16_0      =>	'1'                                                      ,
      		local_read_req_from_the_nios_bts_port_ddr3_x16_0        =>	mem_local_read_req                                       ,
      		local_ready_to_the_nios_bts_port_ddr3_x16_0             =>	mem_local_ready                                          ,
      		--local_reset_n_from_the_nios_bts_port_ddr3_x16_0         =>	                                                     ,
      		local_size_from_the_nios_bts_port_ddr3_x16_0            =>	mem_local_size                                           ,
      		local_wdata_from_the_nios_bts_port_ddr3_x16_0           =>	mem_local_wdata                                          ,
      		local_wdata_req_to_the_nios_bts_port_ddr3_x16_0         =>	internal_mem_local_wdata_req                             ,
      		local_write_req_from_the_nios_bts_port_ddr3_x16_0       =>	mem_local_write_req                                      ,
      		pattern_sync_acquired_from_the_nios_bts_port_ddr3_x16_0 =>	pattern_sync_acquired                                    ,
      		plls_in_locked_to_the_nios_bts_port_ddr3_x16_0          =>	'1'                                                      ,
      		plls_locked_from_the_nios_bts_port_ddr3_x16_0           =>	plls_locked                                              ,
      		reset_n                                                 =>	nios_reset_n                                             ,
      		reset_n_to_the_nios_bts_port_ddr3_x16_0                 =>	cpu_resetn                                               ,
      		start_pb_to_the_nios_bts_port_ddr3_x16_0                =>	not user_pb(0)                                           ,
      		test_complete_from_the_nios_bts_port_ddr3_x16_0         =>	tst_complete,
      		
		  adsc_n_to_the_max2_inf => adsc_n_to_the_max2_inf,
		  bw_n_to_the_max2_inf => max2_ben,
		  bwe_n_to_the_max2_inf => max2_wen,
		  chipenable1_n_to_the_max2_inf => max2_csn,
		  outputenable_n_to_the_max2_inf => max2_oen,
		  tri_state_bridge_0_address => fsm_a(19 downto 0),
		  tri_state_bridge_0_data => fsm_d,

		  led_from_the_heartbeat_0 => led_from_the_heartbeat_0
      		
	);      
  
	nios2_pll_inst : nios2_pll PORT MAP (
		inclk0	=> clkin_top_p, --125MHz default
		c0	 		=> nios_clk
	);	
		
		max2_clk <= nios_clk;

  --<< START MEGAWIZARD INSERT DLL

  --<< END MEGAWIZARD INSERT DLL

  --<< start europa
  --vhdl renameroo for output signals
  mem_addr <= internal_mem_addr;
  --vhdl renameroo for output signals
  mem_ba <= internal_mem_ba;
  --vhdl renameroo for output signals
  mem_cas_n <= internal_mem_cas_n;
  --vhdl renameroo for output signals
  mem_cke <= internal_mem_cke;
  --vhdl renameroo for output signals
  mem_cs_n <= internal_mem_cs_n;
  --vhdl renameroo for output signals
  mem_dm <= internal_mem_dm;
  --vhdl renameroo for output signals
  mem_odt <= internal_mem_odt;
  --vhdl renameroo for output signals
  mem_ras_n <= internal_mem_ras_n;
  --vhdl renameroo for output signals
  mem_reset_n <= internal_mem_reset_n;
  --vhdl renameroo for output signals
  mem_we_n <= internal_mem_we_n;
  --vhdl renameroo for output signals
  --pnf <= internal_pnf;
  --vhdl renameroo for output signals
  --pnf_per_byte <= internal_pnf_per_byte;
  --vhdl renameroo for output signals
  --test_complete <= internal_test_complete;
  --vhdl renameroo for output signals
  --test_status <= internal_test_status;  
  
  internal_mem_local_wdata_req	<= mem_local_write_req and mem_local_ready; 
  local_burstbegin_sig  	<= internal_local_burstbegin_sig and mem_local_ready;
  ddr3_global_reset_n		<= cpu_resetn and (gpo(0)); -- (user_dipsw(0) or (gpo_top(0))) ;   
  ddr3_soft_reset_n		<= gpo(1); -- or user_dipsw(1);

  user_led(3) <= not error_latch;
  user_led(2) <= not tst_complete;
  user_led(1) <= not pattern_sync_acquired;
  user_led(0) <= not plls_locked;
 -- nios_clk    <= clkin_top_p;	-- 125 MHz!
  nios_reset_n	<=	user_pb(0) or user_pb(1);
  
  
  pcie_led_x1 <= led_from_the_heartbeat_0;
  pcie_led_x4 <= led_from_the_heartbeat_0;
  pcie_led_x8 <= led_from_the_heartbeat_0;
end europa;

